#pragma once

#include <lektor/defines.h>
#include <stdnoreturn.h>
#include <stddef.h>

#define LKT_OPT_NULL { .name = NULL, .call = NULL, .name_len = 0 }

struct lkt_cmd_args {
    int argc;               /* The number of arguments passed.  */
    const char **argv;      /* An array of argument passed.     */
};

typedef void (*lkt_cmd_callback)(struct lkt_cmd_args *);

struct lkt_cmd_opt {
    const char *name;
    size_t name_len;
    lkt_cmd_callback call;
};

/* Parse the command line with the list of options. No parameter may be NULL.
   Does not return. */
noreturn void lkt_cmd_parse(struct lkt_cmd_opt *opts, int argc, const char **argv, void (*help)(void));
