#pragma once

#define LKT_MAX_SQLITE_STATEMENT    1024
#define PROTECTED_DATABASE          "disk"
#define BUFFER_MAX                  4096

#define LKT_DATABASE_NAME_KID           "id"
#define LKT_DATABASE_NAME_KNAME         "source_name"
#define LKT_DATABASE_NAME_KTITLE        "song_title"
#define LKT_DATABASE_NAME_KCAT          "song_type"
#define LKT_DATABASE_NAME_KTYPE         "category"
#define LKT_DATABASE_NAME_KAUTHOR       "author_name"
#define LKT_DATABASE_NAME_KAUTHOR_YEAR  "author_year"
#define LKT_DATABASE_NAME_KLANG         "language"
#define LKT_DATABASE_KARA_COLUMNT_ANY   "any_col"

#define LEKTOR_TAG_MAX 256

#ifndef LKT_MESSAGE_ARGS_MAX
#define LKT_MESSAGE_ARGS_MAX 32
#endif

#ifndef LKT_MESSAGE_MAX
#define LKT_MESSAGE_MAX 2048
#endif

enum mpd_idle_flag {
    MPD_IDLE_NONE               = 0,

    MPD_IDLE_DATABASE           = ( 1 << 1  ),
    MPD_IDLE_UPDATE             = ( 1 << 2  ),
    MPD_IDLE_STORED_PLAYLIST    = ( 1 << 3  ),
    MPD_IDLE_PLAYLIST           = ( 1 << 4  ),
    MPD_IDLE_PLAYER             = ( 1 << 5  ),
    MPD_IDLE_MIXER              = ( 1 << 6  ),
    MPD_IDLE_OUTPUT             = ( 1 << 7  ),
    MPD_IDLE_OPTIONS            = ( 1 << 8  ),
    MPD_IDLE_PARTITION          = ( 1 << 9  ),
    MPD_IDLE_STICKER            = ( 1 << 10 ),
    MPD_IDLE_SUBSCRIPTION       = ( 1 << 11 ),
    MPD_IDLE_MESSAGE            = ( 1 << 12 ),

    MPD_IDLE_ALL =
        MPD_IDLE_DATABASE | MPD_IDLE_UPDATE | MPD_IDLE_STORED_PLAYLIST  |
        MPD_IDLE_PLAYLIST | MPD_IDLE_PLAYER | MPD_IDLE_MIXER            |
        MPD_IDLE_OUTPUT | MPD_IDLE_OPTIONS | MPD_IDLE_PARTITION         |
        MPD_IDLE_STICKER | MPD_IDLE_SUBSCRIPTION | MPD_IDLE_MESSAGE,
};
