#define _POSIX_C_SOURCE 200809L

#include <lektor/cmd.h>
#include <sys/types.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <stdio.h>

noreturn void
lkt_cmd_parse(struct lkt_cmd_opt *opts, int argc, const char **argv, void (*help)(void))
{
    int count = 0, is_ok, offset = 0;
    struct lkt_cmd_opt *it = opts;
    lkt_cmd_callback call[2] = { NULL, NULL };

    if (argc == 0 || *argv == NULL)
        goto no_args;

    while (it && it->name) {
        is_ok = (! strncasecmp(argv[0], it->name, strlen(argv[0])));
        call[is_ok] = it->call;
        count += is_ok;
        it = opts + (++offset);
    }

    if (count > 1)
        goto not_exclusive;

    if (!call[1])
        goto not_found;

    struct lkt_cmd_args arguments = {
        .argc = argc - 1,
        .argv = (const char **) & (argv[1]),
    };

    /* This call should exit. */
    call[1](&arguments);
    exit(EXIT_FAILURE);

not_found:
    fprintf(stderr, "Command '%s' could not be found\n", argv[0]);
    exit(EXIT_FAILURE);

no_args:
    help();

not_exclusive:
    fprintf(stderr, "Failed to determine which option to choose, '%s' is not exclusive\n", argv[0]);
    exit(EXIT_FAILURE);
}
